<script lang="ts">
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default {
  name: 'Hero',
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      variant: '',
    };
  },
  created() {
    if (this.$route.query.variant) {
      const paramVariant = this.$route.query.variant;
      if (paramVariant === 'smb') {
        this.variant = 'smb';
      } else if (paramVariant === 'ci') {
        this.variant = 'ci';
      } else if (paramVariant === 'security') {
        this.variant = 'security';
      } else this.variant = 'default';
    } else this.variant = 'default';
  },
};
</script>

<template>
  <section class="hero" :class="data[variant].class">
    <SlpContainer>
      <div class="flex" data-aos="fade-up" data-aos-duration="500">
        <div class="form-container">
          <div class="header">
            <!-- Create component for pill -->
            <a
              v-if="data[variant].pill"
              :href="data[variant].button.url"
              variant="primary"
              :data-ga-name="data[variant].button.dataGaName"
              data-ga-location="hero"
              class="pill slp-mb-8"
            >
              <SlpIcon
                :v-if="data[variant].pill.icon"
                :name="data[variant].pill.icon.name"
                :variant="data[variant].pill.icon.variant"
                :alt="data[variant].pill.icon.alt"
                :hex-color="data[variant].pill.icon.hex_color"
              />
              <SlpTypography tag="p" variant="body3-bold"
                >{{ data[variant].pill.type }}
              </SlpTypography>
            </a>
            <SlpTypography tag="h1" variant="heading2-bold" class="slp-mb-16">
              {{ data[variant].heading }}
            </SlpTypography>
            <SlpTypography
              v-if="data[variant].subtitle"
              tag="p"
              variant="heading4"
              class="slp-mb-32"
            >
              {{ data[variant].subtitle }}
            </SlpTypography>
            <SlpTypography
              v-if="data[variant].text"
              tag="p"
              variant="heading5"
              class="slp-mb-32"
            >
              {{ data[variant].text }}
            </SlpTypography>
          </div>

          <div id="form" class="slp-mb-32 form">
            <SlpButton
              :href="data[variant].button.url"
              variant="primary"
              :data-ga-name="data[variant].button.dataGaName"
              data-ga-location="hero"
            >
              {{ data[variant].button.text }}
              <SlpIcon
                v-if="data[variant].button.icon_name"
                class="learn-more-icon slp-ml-8"
                name="chevron-lg-right"
                variant="product"
              />
            </SlpButton>
            <SlpTypography
              v-if="data[variant].terms"
              tag="span"
              variant="body3"
              class="disclaimer"
            >
              <span v-html="$md.render(data[variant].terms)"></span>
            </SlpTypography>
          </div>
        </div>
        <div class="content">
          <lite-vimeo
            v-if="data[variant].video_url"
            :videoid="
              getVimeoVideoId(createVideoSource(data[variant].video_url))
            "
            class="video"
            autoplay
          ></lite-vimeo>
          <div>
            <SlpTypography variant="body1" tag="p" class="video-note">
              {{ data[variant].video_note }}
            </SlpTypography>
            <div
              v-for="item in data[variant].icon_list"
              :key="item.icon_name"
              class="list-item"
            >
              <img
                v-if="item.icon_src"
                :src="item.icon_src"
                aria-hidden="true"
                alt=""
                class="icon"
              />
              <SlpIcon
                v-else
                variant="marketing"
                :name="item.icon_name"
                size="md"
                hex-color="#171321"
              />
              <SlpTypography tag="p" variant="body1">{{
                item.text
              }}</SlpTypography>
            </div>
          </div>
          <div
            v-if="data[variant].background_image"
            class="column slp-col-md-5 hero-background"
          >
            <div class="hero-background__image">
              <img
                :src="data[variant].background_image.url"
                :alt="data[variant].background_image.alt"
                class="hero-background__image--infinity"
              />
            </div>
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.hero {
  background: $color-surface-50;
  padding-top: $spacing-96;
  padding-bottom: 110px;

  .flex {
    display: flex;
    gap: 120px;
    align-items: center;
    @media (max-width: $breakpoint-lg) {
      gap: 20px;
    }
    @media (max-width: $breakpoint-xl) {
      gap: 30px;
    }
    @media (max-width: $breakpoint-2xl) {
      gap: 40px;
    }
  }

  .pill {
    background-color: $color-surface-950;
    display: inline-flex;
    padding: 4px 12px;
    align-items: flex-start;
    gap: 8px;
    border-radius: 20px;
    color: $color-secondary-300;
    p {
      margin-bottom: 0 !important;
    }
    .slp-icon {
      margin-top: 2px;
    }
  }
  .form-container {
    flex: 1 0 45%;

    .header {
      h1 {
        max-width: 520px;
        font-weight: 660px;
      }

      p {
        display: block;
        margin-bottom: $spacing-24;
      }
    }

    @media (max-width: $breakpoint-md) {
      .header {
        p {
          margin-bottom: $spacing-16;
        }
      }
    }
  }

  .form {
    background: $color-surface-50;
    border-radius: 8px;
    max-width: 540px;

    .disclaimer {
      display: block;
      color: $color-text-300;
      margin-top: $spacing-24;
    }

    @media (max-width: $breakpoint-md) {
      .slp-btn-primary {
        width: 100%;
        justify-content: center;
      }

      .disclaimer {
        margin-top: $spacing-16;
      }
    }
  }

  .content {
    flex: 1 0 50%;
  }

  .list-item {
    margin-bottom: $spacing-24;
    display: flex;
    align-items: center;

    .slp-icon,
    .icon {
      margin-right: $spacing-16;
      width: 32px;
      height: 32px;
      color: black;
    }
  }

  .video {
    margin-bottom: 15px;
    width: 100%;
    height: 275px;
    border-radius: 8px;
    &:deep {
      .vp-center {
        justify-content: flex-start !important;
      }
    }
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 0;

    .flex {
      flex-direction: column;
      gap: 0;
    }

    .video {
      margin: 0 0 $spacing-24 0;
      height: 200px;
    }
  }

  &.purple {
    background: linear-gradient(99deg, #6656af 0%, #302f6c 100%);
    color: white;
    overflow: hidden;
    padding: 0px;
    .slp-container {
      display: block;
      overflow: visible;
      @media (min-width: $breakpoint-md) {
        padding: $spacing-96 0px;
      }
    }
    .form {
      background: transparent;
    }
    @media (max-width: $breakpoint-md) {
      padding: 0 0 $spacing-32;
      .flex {
        flex-direction: column-reverse;
        gap: 0;
      }
    }
  }

  &-background {
    @media (min-width: $breakpoint-md) {
      position: absolute;
      top: 0px;
      height: 120%;
      margin-top: -$spacing-32;
      align-items: center;
      justify-content: left !important;
      //margin: 16px 0 48px;
      aspect-ratio: 14 / 9;
      display: flex;
      flex: 0 0 41.6666666667%;
      max-width: 41.6666666667%;
      overflow: visible;
      &__image {
        height: 100%;
        display: flex;
        z-index: -1;
        &--rounded {
          border-radius: 50%;
        }
      }
    }
    @media (max-width: $breakpoint-md) {
      &__image {
        &--infinity {
          max-width: 600px;
          max-height: 300px;
        }
      }
    }
  }
}

.video-note {
  margin-bottom: 40px;
}
</style>
